package framework 
{
	import flash.utils.ByteArray;
	import framework.resource.ResourceCsv;
	/**
	 * CSVロードクラス
	 * @author syun
	 */
	public class CsvLoader
	{
		// ■定数
		// ・行
		public static const ROW_HEADER:int = 0; // ヘッダ行
		public static const ROW_TYPE:int = 1; // 型定義行
		public static const ROW_START:int = 2; // データ開始行
		
		// ■メンバ変数
		private var m_Header:Object = {};
		private var m_Types:Object = {};
		private var m_Data:Array = [];
		public function CsvLoader(key:String) 
		{
			var data:ByteArray = ResourceCsv.getValue(key);
			var datas:Array = data.toString().split("\r\n");
			for (var i:int = 0; i < datas.length; i++ )
			{
				var line:String = datas[i];
				var items:Array = line.split(",");
				if (items.length == 0) { break; }
				switch(i)
				{
				case ROW_HEADER:
					// 列の名前を保持
					for (var j:int = 0; j < items.length; j++ )
					{
						var k:String = items[j];
						m_Header[k] = j;
					}
					break;
				case ROW_TYPE:
					// 列の型を保持
					m_Types = items;
					break;
				default:
					// データを保持
					m_Data.push(items);
					break;
				}
			}
		}
		
		/**
		 * データ数を取得
		 * @return データ数
		 */
		public function size():int
		{
			return m_Data.length;
		}
		
		/**
		 * 要素を取得
		 * @param	row データ番号（0～size-1)
		 * @param	key 列の名前
		 * @return 要素（文字列）
		 */
		public function get(row:int, key:String):String
		{
			if (m_Header.hasOwnProperty(key) == false)
			{
				throw new Error("指定のデータは存在しません。key=" + key);
			}
			
			var idx:int = m_Header[key];
			return m_Data[row][idx];
		}
		public function getInt(row:int, key:String):int
		{
			return int(get(row, key));
		}
		public function getFloat(row:int, key:String):Number
		{
			return Number(get(row, key));
		}
	}

}