package framework 
{
	import flash.utils.ByteArray;
	import framework.util.Layer2D;
	/**
	 * FMFファイル読み込みクラス
	 * @author syun
	 */
	public class FMFLoader
	{
		private var identifier:String; // 識別文字「FMF_」
		private var datasize:int; // ヘッダを除いたデータサイズ
		private var width:int; // マップの幅
		private var height:int; // マップの高さ
		private var chipwidth:int; // チップの幅
		private var chipheight:int; // チップの高さ
		private var layercount:int; // レイヤー数
		private var bitcount:int; // データのbit数(8/16)
		private var layerArray:Array; // レイヤー配列
		
		public function FMFLoader(bin:ByteArray) 
		{
			bin.endian = "littleEndian";
			layerArray = [];
			identifier = bin.readMultiByte(4, "iso-8859-1");
			datasize = bin.readInt();
			width = bin.readInt();
			height = bin.readInt();
			chipwidth = bin.readByte();
			chipheight = bin.readByte();
			layercount = bin.readByte();
			bitcount = bin.readByte();
			for (var i:int = 0; i < layercount; i++)
			{
				var layer:Layer2D = new Layer2D(width, height);
				layer.setByte(bin);
				layerArray.push(layer);
			}
		}
		public function getLayer(idx:int):Layer2D
		{
			return layerArray[idx];
		}
		public function dump():void
		{
			trace("identifier=" + identifier);
			trace("datasize=" + datasize);
			trace("width=" + width);
			trace("height=" + height);
			trace("chipwidth=" + chipwidth);
			trace("chipheight=" + chipheight);
			trace("bitcount=" + bitcount);
			trace("layercount=" + layercount);
			for (var i:int = 0; i < layercount; i++)
			{
				trace("layer=" + i);
				var layer:Layer2D = layerArray[i];
				layer.dump();
			}
		}
	}

}