package framework 
{
	/**
	 * FPSを表示するクラス
	 * @author syun
	 */
	public class FpsView extends IToken
	{
		private var m_tPrev:Number = 0; // １フレーム前のタイマ
		private var m_tNow:Number = 0; // 現在のタイマ
		private var m_tPast:Number = 0; // 経過時間
		private var m_nFrame:int = 0; // フレーム数
		private var m_Fps:Number = 0; // 実際のFPS
		public static const FPS:Number = 30; // 指定のFPS
		
		public function FpsView() 
		{
		}
		public override function update():void
		{
			if (Debug.isDrawFpsView() == false) { return; }
			
			/*
			while (true)
			{
				var date:Date = new Date();
				m_tNow = date.getTime();
				var d:Number = (m_tNow - m_tPast);
				if (d > 1000/FPS)
				{
					m_tPast += d;
					trace("exe!" + d);
					break;
				}
				trace(d);
				return;
			}
			*/
			
			var date:Date = new Date();
			m_tNow = date.getTime();
			m_tPast += m_tNow - m_tPrev;
			m_nFrame++;
			if (m_nFrame % FPS == 0)
			{
				m_Fps = 1000.0 / (m_tPast / FPS);
				m_nFrame = 0;
				m_tPast = 0;
			}
			m_tPrev = m_tNow;
		}
		public override function draw():void
		{
			if(Debug.isDrawFpsView())
			{
				IToken._f.drawAscii("FPS:" + Math.floor(m_Fps), 0, Main.HEIGHT - 8);
			}
		}
		
	}

}