package framework 
{
	import flash.geom.Rectangle;
	import framework.device.graphics.FontObj;
	import framework.device.input.GamePad;
	import framework.util.RectEx;
	/**
	 * GUIのボタンクラス
	 * @author syun
	 */
	public class GuiButton extends IToken
	{
		private var m_TextObj:FontObj;
		private var m_Text:String;
		private var m_HitRect:RectEx;
		private var m_bOver:Boolean;
		private var m_SeOver:String;
		private var m_SePush:String;
		private var m_bEnable:Boolean;
		private var m_bUseTextObj:Boolean;
		public function GuiButton(text:String, cx:Number, cy:Number, w:Number, h:Number) 
		{
			m_TextObj = new FontObj();
			setText(text);
			m_HitRect = new RectEx(cx, cy, w, h);
			m_bOver = false;
			m_SeOver = "pi";
			m_SePush = null;
			m_bEnable = true;
			m_bUseTextObj = false;
		}
		/**
		 * 有効無効の切り替え
		 * @param	b
		 */
		public function setEnable(b:Boolean):void
		{
			m_bEnable = b;
			setText(m_Text);
		}
		
		/**
		 * 項目が有効かどうか
		 * @return 有効であれば「true」
		 */
		public function isEnable():Boolean
		{
			return m_bEnable;
		}
		
		/**
		 * TextObjを使うかどうか
		 * @param	b
		 */
		public function setUseTextObj(b:Boolean):void
		{
			m_bUseTextObj = b;
		}
		
		public function setOverSe(str:String):void
		{
			m_SeOver = str;
		}
		private function isOverMouse():Boolean
		{
			if (m_bEnable == false) { return false; } // 選択できない
			
			var pad:GamePad = _i.getPad(0);
			var px:Number = pad.x();
			var py:Number = pad.y();
			return m_HitRect.isHit(px, py);
		}
		/**
		 * 選択されているかどうか
		 * @return
		 */
		public function isOver():Boolean
		{
			return m_bOver;
		}
		public function playPushSe():void
		{
			if (m_SePush)
			{
				_m.play(m_SePush);
			}
		}
		
		/**
		 * 文字の設定
		 * @param	s
		 */
		public function setText(s:String):void
		{
			m_Text = s;
			if (m_bEnable)
			{
				m_TextObj.setFormat(0xFFFFFF, 14, false);
			}
			else
			{
				m_TextObj.setFormat(0x808080, 14, false);
			}
			m_TextObj.setText(s);
		}
		
		/**
		 * 更新
		 */
		public override function update():void
		{
			var bOverPrev:Boolean = m_bOver;
			m_bOver = isOverMouse();
			if (m_bOver && bOverPrev == false)
			{
				if (m_SeOver)
				{
					// アクティブ音を再生する
					_m.play(m_SeOver);
				}
			}
		}
		
		/**
		 * 描画
		 */
		public override function draw():void
		{
			var rect:Rectangle = m_HitRect.getRectangle();
			if (m_bOver)
			{
				var v:int = 0x808080;
				_g.setColor(v);
				_g.fillRectEx2(m_HitRect);
			}
			
			if (m_bUseTextObj)
			{
				m_TextObj.draw2(m_HitRect.left(), m_HitRect.top());
			}
			else
			{
				_f.drawAsciiEx(m_Text, m_HitRect.getX(), m_HitRect.getY());
			}
		}
	}

}