package framework 
{
	/**
	 * アイテムリスト
	 * @author syun
	 */
	public class GuiItemList extends IToken
	{
		protected var cx:Number;
		protected var cy:Number;
		protected var dy:Number;
		protected var width:Number;
		protected var height:Number
		private var m_BtnList:Vector.<GuiButton>;
		/**
		 * コンストラクタ
		 */
		public function GuiItemList(cx:Number, cy:Number, dy:Number, width:Number, height:Number) 
		{
			this.cx = cx;
			this.cy = cy;
			this.dy = dy;
			this.width = width;
			this.height = height;
			m_BtnList = new Vector.<GuiButton>;
		}
		
		/**
		 * 登録したアイテムを削除する
		 */
		public function clear():void
		{
			m_BtnList = new Vector.<GuiButton>;
		}
		
		/**
		 * リストアイテムの数を取得する
		 * @return アイテムの数
		 */
		public function size():int
		{
			return m_BtnList.length;
		}
		
		/**
		 * 選択中の項目を取得する
		 * @return インデックス
		 */
		public function idx():int
		{
			var i:int = 0;
			for each (var btn:GuiButton in m_BtnList)
			{
				if (btn.isOver()) { return i; }
				i++;
			}
			return -1;
		}
		
		/**
		 * アイテムを追加する
		 * @param	name アイテム名
		 * @param	bEnable
		 */
		public function addItem(name:String, bEnable:Boolean=true):void
		{
			var x:Number = cx;
			var y:Number = cy + dy * size();
			var item:GuiButton = new GuiButton(name, x, y, width, height);
			item.setUseTextObj(true);
			item.setEnable(bEnable);
			m_BtnList.push(item);
		}
		
		/**
		 * 更新
		 */
		override public function update():void 
		{
			for each(var btn:GuiButton in m_BtnList)
			{
				btn.update();
			}
		}
		
		/**
		 * 描画
		 */
		override public function draw():void 
		{
			for each(var btn:GuiButton in m_BtnList)
			{
				btn.draw();
			}
		}
		
	}

}