package framework 
{
	/**
	 * 数学・乱数関連
	 * @author syun
	 */
	public class Maths
	{
		
		/**
		 * コンストラクタ
		 */
		public function Maths() 
		{
		}
		
		/**
		 * 配列から要素をランダムに取り出す
		 * @param	a 要素配列
		 * @return 取り出した要素
		 */
		public static function choice(a:Array):int
		{
			var idx:int = rand(a.length);
			return a[idx];
		}
		
		/**
		 * 乱数を取得する(0～(a-1))
		 * @param	a
		 * @return 乱数値
		 */
		public static function rand(a:int):int
		{
			return int(Math.random() * a);
		}
		
		/**
		 * 乱数を取得する(a <= x <= b)
		 * @param	a
		 * @param	b
		 * @return a～bの範囲の乱数
		 */
		public static function randInt(a:int, b:int):int
		{
			var tmp:int = int(Math.random() * 1000);
			return (b - a + 1) * tmp / 1000 + a;
		}
		public static function randNum(a:Number, b:Number):Number
		{
			return (b - a) * Math.random() + a;
		}
		public static function sinEx(deg:Number):Number
		{
			return Math.sin(deg2rad(deg));
		}
		public static function cosEx(deg:Number):Number
		{
			return Math.cos(deg2rad(deg));
		}
		public static function atan2Ex(x:Number, y:Number):Number
		{
			return rad2deg(Math.atan2(-y, x));
		}
		public static function sqrt(a:Number):Number
		{
			return Math.sqrt(a);
		}
		public static function distance(dx:Number, dy:Number):Number
		{
			return Math.sqrt(dx * dx + dy * dy);
		}
		/**
		 * ラジアンを度に変換
		 * @param	rad
		 * @return 度
		 */
		public static function rad2deg(rad:Number):Number
		{
			return rad * 180 / Math.PI;
		}
		/**
		 * 度をラジアンに変換
		 * @param	deg
		 * @return ラジアン
		 */
		public static function deg2rad(deg:Number):Number
		{
			return deg * Math.PI / 180;
		}
	}

}