package framework.device.graphics 
{
	import flash.display.Bitmap;
	/**
	 * ...
	 * @author syun
	 */
	public class FontManager
	{
		// 定数
		private static const decoder:String
			= "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz.()[]#$%&'\"!?^+-*/=;:_<>|\\";
		private static const WIDTH:Number = 8; // フォントの幅
		private static const HEIGHT:Number = 8; // フォントの高さ
		private static const COLUMN:int = 16; // フォントテクスチャの一行の文字数
			
		// ASCIIフォント
		[Embed(source='../../../../resource/font/font.png')]
		private static var _ascii:Class;
		private static var _ASCII:Bitmap;
		
		private var _g:GraphicManager;
		
		/**
		 * コンストラクタ
		 */
		public function FontManager(g:GraphicManager) 
		{
			_load();
			_g = g;
		}
		/**
		 * リソースロード
		 */
		private function _load():void
		{
			_ASCII = new _ascii();
		}
		
		/**
		 * Asciiフォントの描画
		 * @param	str
		 * @param	x
		 * @param	y
		 * @param	scale
		 */
		public function drawAscii(str:String, x:Number, y:Number, scale:Number=1):void
		{
			var px:Number = x;
			for (var i:int; i < str.length; i++)
			{
				var c:String = str.charAt(i);
				if (c == "\n")
				{
					px = x;
					y += HEIGHT;
					continue;
				}
				var idx:int = decoder.indexOf(c);
				if (idx >= 0)
				{
					var ox:Number = (idx % COLUMN) * WIDTH;
					var oy:Number = Math.floor(idx / COLUMN) * HEIGHT;
					if (scale == 1)
					{
						_g.drawFast2(_ASCII, px, y, ox, oy, WIDTH, HEIGHT);
					}
					else
					{
						_g.draw2(_ASCII, px, y, ox, oy, WIDTH, HEIGHT, scale, scale);
					}
				}
				px += WIDTH * scale;
			}
		}
		public function drawAsciiEx(str:String, cx:Number, cy:Number, scale:Number = 1):void
		{
			var x:Number = cx - Math.floor(str.length / 2) * (WIDTH * scale);
			if (str.length % 2 == 1)
			{
				// 文字数が奇数
				cx -= WIDTH / 2;
			}
			
			var y:Number = cy - (HEIGHT / 2) * scale;
			drawAscii(str, x, y, scale);
		}
	}

}