package framework.device.graphics
{
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import framework.IToken;
	
	/**
	 * フォントオブジェクトクラス
	 * @author syun
	 */
	public class FontObj extends IToken
	{
		private var m_Matrix:Matrix;
		private var m_Format:TextFormat;
		private var m_TextField:TextField;
		public function FontObj() 
		{
			m_Matrix = new Matrix();
			m_Format = new TextFormat();
			m_TextField = new TextField();
			//m_TextField.autoSize = "center";
			setFormat();
		}
		public function setFormat(color:uint=0xFFFFFF, size:int=16, bold:Boolean = true, bCenter:Boolean=false):void
		{
			m_Format.color = color;
			m_Format.size = size;
			m_Format.bold = bold;
			m_TextField.defaultTextFormat = m_Format;
			if (bCenter)
			{
				// センタリングする
				m_TextField.width = 100;
				m_TextField.autoSize = TextFieldAutoSize.CENTER;
			}
			else
			{
				m_TextField.width = 320;
				m_TextField.autoSize = TextFieldAutoSize.NONE;
			}
		}
		public function setText(str:String):void
		{
			if (str == null) { throw new Error("Error: FontObj.setText -> str is null"); }
			m_TextField.text = str;
		}
		public function getTextField():TextField
		{
			return m_TextField;
		}
		public function getMatrix():Matrix
		{
			return m_Matrix;
		}
		public override function draw():void
		{
			_g.drawFont(this);
		}
		public function draw2(x:Number, y:Number):void
		{
			m_Matrix.identity();
			m_Matrix.translate(x, y);
			draw();
		}
	}

}