package framework.device.input
{
	import joystick.JoystickState;
	
	/**
	 * ゲームパッドの入力管理
	 * @author syun
	 */
	public class GamePad
	{
		private var m_Mouse:Mouse;
		private var m_Keyboard:Keyboard;
		public var joystickState:JoystickState;
		
		public function GamePad() 
		{
		}
		
		public function setMouse(m:Mouse):void
		{
			m_Mouse = m;
		}
		public function setKeyboard(k:Keyboard):void
		{
			m_Keyboard = k;
		}
		public function setJoystickState(j:JoystickState):void
		{
			joystickState = j;
		}
		
		public function isPress(index:uint):Boolean
		{
			if(joystickState)
			{
				if (joystickState.isHeld(index) == true) { return true; }
				if (m_Keyboard.isPress(index) == true) { return true; }
			}
			if (m_Keyboard.isPress(index)) { return true; }
			if (m_Mouse.isPress()) { return true; }
			return false;
		}
		
		public function isPush(index:uint):Boolean
		{
			if(joystickState)
			{
				if (joystickState.isDown(index) == true) { return true; }
				if (m_Keyboard.isPush(index) == true); { return true; }
			}
			if (m_Keyboard.isPush(index) == true) { return true; }
			if (m_Mouse.isPush()) { return true; }
			
			return false;
		}
		
		public function isPushEnter():Boolean
		{
			if (isPush(0)) { return true; }
			if (isPush(3)) { return true; }
			
			return false;
		}
		
		public function isPressEnter():Boolean
		{
			if (isPress(0)) { return true; }
			if (isPress(3)) { return true; }
			
			return false;
		}
		
		public function isPushCancel():Boolean
		{
			if (isPush(1)) { return true; }
			
			return false;
		}
		
		
		public function getX():int {
			if (joystickState == null) {
				return m_Keyboard.getX();
			}else {
				var x:int = joystickState.x + m_Keyboard.getX();
				return Math.min(1, Math.max( -1, x));
			}
		}
		
		public function getY():int
		{
			if (joystickState == null)
			{
				return m_Keyboard.getY();
			}
			else
			{
				var y:int = joystickState.y + m_Keyboard.getY();
				return Math.min(1, Math.max( -1, y));
			}
		}
		
		public function isPushLeft():Boolean
		{
			if (joystickState)
			{
				if (joystickState.x < -0.5)
				{
					return true;
				}
			}
			return m_Keyboard.isPushArrow(Keyboard.ARROW_LEFT);
		}
		
		public function isPushUp():Boolean
		{
			if (joystickState)
			{
				if (joystickState.y < -0.5)
				{
					return true;
				}
			}
			return m_Keyboard.isPushArrow(Keyboard.ARROW_UP);
		}
		
		public function isPushRight():Boolean
		{
			if (joystickState)
			{
				if (joystickState.x > 0.5)
				{
					return true;
				}
			}
			return m_Keyboard.isPushArrow(Keyboard.ARROW_RIGHT);
		}
		public function isPushDown():Boolean
		{
			if (joystickState)
			{
				if (joystickState.y > 0.5)
				{
					return true;
				}
			}
			return m_Keyboard.isPushArrow(Keyboard.ARROW_DOWN);
		}
		
		/**
		 * いずれかの方向キーを押したかどうか
		 * @return
		 */
		public function isPushArrawAny():Boolean
		{
			if (isPushLeft()) { return true; }
			if (isPushUp()) { return true; }
			if (isPushRight()) { return true; }
			if (isPushDown()) { return true; }
			
			return false;
		}
		
		public function x():int
		{
			return m_Mouse.x();
		}
		public function y():int
		{
			return m_Mouse.y();
		}
	}

}