package framework.device.sound
{
	import flash.media.Sound;
	import framework.Debug;
	import framework.resource.ResourceImage;
	import framework.resource.ResourceSound;
	
	/**
	 * サウンド管理
	 * @author syun
	 */
	public class SoundManager
	{
		private var m_Pool:Object = { };
		private var m_Bgm:SoundWrapper = null;
		/**
		 * コンストラクタ
		 */
		public function SoundManager() 
		{
			for (var key:String in ResourceSound.getHash())
			{
				var snd:SoundWrapper = new SoundWrapper(ResourceSound.getValue(key));
				m_Pool[key] = snd;
			}
		}
		/**
		 * SE再生
		 * @param	key サウンド名
		 */
		public function play(key:String):void
		{
			if (Debug.isSe() == false) { return; }
			var snd:SoundWrapper = m_Pool[key];
			snd.stop();
			snd.play();
		}
		
		/**
		 * ループ再生する
		 * @param	key サウンド名
		 * @param	cnt ループ回数（0で無限ループ)
		 */
		public function loop(key:String, cnt:int = 0):void
		{
			if (Debug.isBgm() == false) { return; }
			stop();
			m_Bgm = m_Pool[key];
			m_Bgm.loop(cnt);
		}
		
		/**
		 * ループ再生を停止
		 */
		public function stop():void
		{
			if (m_Bgm)
			{
				m_Bgm.stop();
				m_Bgm = null;
			}
		}
		
		/**
		 * ループ再生中かどうか
		 * @return ループ再生中なら「true」
		 */
		public function isLoop():Boolean
		{
			if (m_Bgm)
			{
				return m_Bgm.isStop() == false;
			}
			return false;
		}
	}

}