﻿package framework.device.sound
{
	import flash.display.*;
	import flash.events.*;
	import flash.events.TimerEvent;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.utils.Timer;

	/**
	 * 簡単にサウンド再生できるクラス
	 * http://level0.kayac.com/2009/01/post_10.php
	 * @author hidaka (KAYAC)
	 */
	public class SoundWrapper
	{
		private var vol:int = 100;
		private var tmpvol:int;
		private var tarvol:int;
		private var sound:Sound
		private var channel:SoundChannel;
		private var trans:SoundTransform = new SoundTransform();
		private var myTimer:Timer;
		private var Tcounter:int;

		public function SoundWrapper(s:Sound):void
		{
			sound = s;
		}

		// ボリューム指定、0-100
		public function setvol(k:int):void
		{
			vol = k;
			if (channel != null)
			{
				trans.volume =  k/100;
				channel.soundTransform = trans;
				if(k == 0) { stop(); }
			}
		}
		
		// 1回再生
		public function play():void
		{
			trans.volume = vol/100;
			channel  = sound.play(0, 1, trans);
		}
		
		// 指定回数再生。0だとずっとループ
		public function loop(k:int):void
		{
			trans.volume = vol/100;
			if(k == 0) { k = 9999; }
			channel = sound.play(0, k, trans);
			channel.addEventListener(Event.SOUND_COMPLETE, playEndHandler);
		}
		
		public function isStop():Boolean
		{
			return channel == null;
		}
		
		// 停止
		public function stop():void
		{
			if (channel != null)
			{
				channel.stop();
				channel = null;
			}
		}
		
		// フェード。k:フェード後音量（0-100）、n:移行秒数
		// 先にplaySound()かloopSound()やってから。
		public function fade(tvol:int, k:int):void
		{
			if (channel != null)
			{
				tarvol= tvol;
				tmpvol = vol;
				Tcounter = 0;
				myTimer = new Timer(k*1000/10, 10);
				myTimer.addEventListener("timer", timerHandler);
				myTimer.addEventListener("timerComplete", timerHandler2);
				myTimer.start();
			}
		}
		
		public function timerHandler2(e:TimerEvent):void
		{
			setvol(tarvol);
		}
		
		public function timerHandler(e:TimerEvent):void
		{
			Tcounter++;
			tmpvol = Tcounter/10 * (tarvol - vol) + vol;
			//trace(tmpvol);
			trans.volume =  tmpvol/100;
			channel.soundTransform = trans;
		}
		
		public function playEndHandler(e:Event):void
		{
			stop();
		}
	}
}