package framework.scene
{
	/**
	 * シーン管理
	 * @author syun
	 */
	public class SceneManager
	{
		private static var m_Pool:Object = { };
		private static var m_Current:IScene;
		private static var m_CurrentName:String;
		private static var m_Stack:Vector.<String> = new Vector.<String>();
		
		public function SceneManager() 
		{
		}
		/**
		 * シーンの追加
		 * @param	name
		 * @param	scene
		 */
		public static function add(name:String, scene:IScene):void
		{
			m_Pool[name] = scene;
		}
		/**
		 * 現在のシーンを取得する
		 */
		public static function getCurrent():IScene
		{
			return m_Current;
		}
		
		/**
		 * 現在実行中のシーン名を取得する
		 * @return
		 */
		public static function getCurrentName():String
		{
			return m_CurrentName;
		}
		
		/**
		 * 名前を指定してシーンを取得する
		 * @param	name
		 * @return
		 */
		public static function getByName(name:String):IScene
		{
			if (m_Pool.hasOwnProperty(name))
			{
				return m_Pool[name];
			}
			
			return null;
		}
		
		/**
		 * シーンを切り替える
		 * @param	name
		 */
		public static function change(name:String):void
		{
			m_CurrentName = name;
			m_Current = m_Pool[name];
		}
		
		/**
		 * 現在のシーンをスタックに積んで切り替える
		 * @param	name
		 */
		public static function changePush(name:String):void
		{
			m_Stack.push(m_CurrentName);
			change(name);
		}
		
		/**
		 * スタックに積んでいるシーンを取り出して切り替える
		 */
		public static function changePop():void
		{
			if (m_Stack.length == 0)
			{
				return;
			}
			var name:String = m_Stack.pop();
			change(name);
		}
	}

}