package framework.token
{
	/**
	 * トークン管理
	 * @author syun
	 */
	public class TokenManager
	{
		/**
		 * 管理する要素
		 */
		protected var m_Pool:Array;
		/**
		 * コンストラクタ
		 */
		public function TokenManager(Type:Class, Size:int) 
		{
			m_Pool = [];
			for (var i:int; i < Size; i++)
			{
				m_Pool.push(new Type());
			}
		}
		/**
		 * 要素の追加
		 * @param	x
		 * @param	y
		 * @param	deg
		 * @param	speed
		 * @param	ax
		 * @param	ay
		 * @return
		 */
		public function add(x:Number, y:Number, deg:Number=0, speed:Number=0, ax:Number=0, ay:Number=0):Token
		{
			for each(var s:Token in m_Pool)
			{
				if (s.exist) { continue; }
				s.create(x, y, deg, speed, ax, ay);
				return s;
			}
			return null;
		}
		
		/**
		 * トークンの生存数を返す
		 * @return 生存数
		 */
		public function count():int
		{
			var ret:Number = 0;
			for each(var t:Token in m_Pool)
			{
				if (t.exist == false) { continue; }
				ret++;
			}
			return ret;
		}
		/**
		 * 管理しているToken配列を返す
		 * @return Token配列
		 */
		public function getArray():Array
		{
			return m_Pool;
		}
		
		/**
		 * 消滅
		 */
		public function vanish():void
		{
			for each(var t:Token in m_Pool)
			{
				t.exist = false;
			}
		}
		/**
		 * 更新
		 */
		public function update():void
		{
			for each(var t:Token in m_Pool)
			{
				if (t.exist == false) { continue; }
				t.update();
			}
		}
		/**
		 * 描画
		 */
		public function draw():void
		{
			for each(var t:Token in m_Pool)
			{
				if (t.exist == false) { continue; }
				t.draw();
			}
		}
		
	}

}