package framework.util 
{
	import framework.Application;
	import framework.device.graphics.FontObj;
	import framework.IToken;
	import framework.Maths;
	/**
	 * リストアイテム
	 * @author syun
	 */
	public class GuiItem extends IToken
	{
		private var m_Timer:int;
		private var m_TextObj:FontObj;
		private var m_Text:String;
		private var m_HitRect:Rect;
		private var m_bEnable:Boolean;
		private var m_bSelected:Boolean;
		public function GuiItem(text:String, x:Number, y:Number, w:Number, h:Number) 
		{
			m_Timer = 0;
			m_TextObj = new FontObj();
			setText(text);
			m_HitRect = new Rect(x, y, w, h);
			m_bEnable = true;
			m_bSelected = false;
		}
		
		/**
		 * 有効・無効を切り替える
		 * @param	b
		 */
		public function setEnable(b:Boolean):void
		{
			m_bEnable = b;
			setText(m_Text);
		}
		
		/**
		 * 有効かどうか
		 * @return 有効であれば「true」
		 */
		public function isEnable():Boolean
		{
			return m_bEnable;
		}
		
		/**
		 * 選択状態にする
		 * @param	b
		 */
		public function setSelected(b:Boolean):void
		{
			m_bSelected = b;
		}
		
		/**
		 * 文字の設定
		 * @param	s
		 */
		public function setText(s:String):void
		{
			m_Text = s;
			if (m_bEnable)
			{
				m_TextObj.setFormat(0xFFFFFF, 14, false);
			}
			else
			{
				m_TextObj.setFormat(0x404040, 14, false);
			}
			m_TextObj.setText(s);
		}
		
		/**
		 * 更新
		 */
		override public function update():void 
		{
			m_Timer++;
		}
		
		/**
		 * 描画
		 */
		override public function draw():void 
		{
			if (m_bSelected)
			{
				var t:int = (m_Timer * 8) % 180;
				var a:Number = 0.2 + 0.3 * Maths.sinEx(t);
				_g.setColor(0xFFFFFF, a);
				_g.fillRect(m_HitRect.x, m_HitRect.y, m_HitRect.width, m_HitRect.height);
			}
			m_TextObj.draw2(m_HitRect.x, m_HitRect.y);
		}
	}

}