package framework.util 
{
	import flash.geom.Point;
	import framework.Maths;
	/**
	 * ...
	 * @author syun
	 */
	public class Vec2D
	{
		private var m_Pos:Point;
		public var x:Number;
		public var y:Number;
		/**
		 * コンストラクタ
		 * @param	x
		 * @param	y
		 */
		public function Vec2D(x:Number=0, y:Number=0) 
		{
			m_Pos = new Point();
			set(x, y);
		}
		/**
		 * X/Yに値をセットする
		 * @param	x
		 * @param	y
		 */
		public function set(x:Number, y:Number):void
		{
			this.x = x;
			this.y = y;
		}
		
		/**
		 * int型にしてX値を取得
		 * @return x
		 */
		public function getX():int
		{
			return int(x);
		}
		
		/**
		 * int型にしてY値を取得
		 * @return y
		 */
		public function getY():int
		{
			return int(y);
		}
		
		/**
		 * Point型にして返す。参照返すだけなので注意
		 * @return
		 */
		public function getPoint():Point
		{
			m_Pos.x = x;
			m_Pos.y = y;
			return m_Pos;
		}
		/**
		 * 速度を返す
		 * @return 速度
		 */
		public function velocity():Number
		{
			return Maths.distance(x, y);
		}
		/**
		 * 正規化する
		 */
		public function normalize():void
		{
			var len:Number = Maths.distance(x, y);
			if (len == 0) { return; }
			x /= len;
			y /= len;
		}
		
	}

}