package util 
{
	/**
	 * 視点
	 * @author syun
	 */
	public class View
	{
		/**
		 * 移動量(X)
		 */
		private var m_Dx:Number;
		
		/**
		 * 移動量(Y)
		 */
		private var m_Dy:Number;
		
		/**
		 * 元の座標(X)
		 */
		private var m_PrevX:Number;
		
		/**
		 * 元の座標(Y)
		 */
		private var m_PrevY:Number;
		
		/**
		 * 移動タイマー
		 */
		private var m_Timer:Number;
		
		/**
		 * コンストラクタ
		 */
		public function View() 
		{
			initialize();
		}
		
		/**
		 * 初期化
		 */
		public function initialize():void
		{
			m_Dx = 0;
			m_Dy = 0;
			m_PrevX = 0;
			m_PrevY = 0;
			m_Timer = 0;
		}
		
		/**
		 * 移動開始
		 * @param	x 目標座標(X)
		 * @param	y 目標座標(Y)
		 */
		public function start(x:Number, y:Number):void
		{
			m_PrevX += m_Dx;
			m_PrevY += m_Dy;
			
			m_Dx = x - m_PrevX;
			m_Dy = y - m_PrevY;
			
			m_Timer = 1;
		}
		
		/**
		 * 更新
		 */
		public function update():void
		{
			// タイマー減衰
			m_Timer *= 0.9;
		}
		
		/**
		 * 座標(X)を取得
		 * @return 座標(X)
		 */
		public function getX():Number
		{
			return m_PrevX + m_Dx * (1 - m_Timer);
		}
		
		/**
		 * 座標(Y)を取得
		 * @return 座標(Y)
		 */
		public function getY():Number
		{
			return m_PrevY + m_Dy * (1 - m_Timer);
		}
	}

}